﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

using System.Windows.Media.Effects;
using System.Windows.Media.Media3D;
using System.IO;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            Uri uri = new Uri(Directory.GetCurrentDirectory() + @"\test.jpg", UriKind.Absolute);
            BitmapImage bmi = new BitmapImage(uri);
            ImageBrush pic = new ImageBrush(bmi);
            EmbossEffect BE = new EmbossEffect();
            BE.Bitmap1 = pic;
            button1.Effect = BE;
        }

        public class EmbossEffect : ShaderEffect
        {

            public Brush Bitmap1
            {
                get
                {
                    this.PaddingBottom = 100;
                    return (Brush)GetValue(Bitmap1Property);
                }
                set { SetValue(Bitmap1Property, value); }
            }

            public static readonly DependencyProperty Bitmap1Property =
                ShaderEffect.RegisterPixelShaderSamplerProperty("Bitmap1", typeof(EmbossEffect), 0);


            public EmbossEffect()
            {
                PixelShader pixelShader = new PixelShader();
                Uri uri = new Uri(Directory.GetCurrentDirectory() + @"\..\..\Shader\shader1.ps", UriKind.Absolute);
                pixelShader.UriSource = uri;
                this.PixelShader = pixelShader;
                UpdateShaderValue(Bitmap1Property);
            }
        }
    }
}
